import { Redis, MemoryCache } from '@/plugins';
interface InterfaceCache {
  redis: Redis,
  memoryCache: MemoryCache
};

export default (cache: InterfaceCache) => {
  return async (ctx, next) => {
    if (cache.redis.isUseRedis) { // 如果redis连接失败，采用内存
      ctx.$redis = cache.redis;
    } else {
      ctx.$redis =cache.memoryCache
    };
    await next();
  };
};
