import Nedb from 'nedb';
import { resolve } from 'path';
import config from '@config';

export interface InterfaceDB {
  [key: string]: Nedb
};

const { localDb } = config;
const filename = name => resolve(localDb._dir, name);

class LocalDb {
  db: InterfaceDB
  constructor(options) {
    const db: InterfaceDB = {}
    const { _dir, ...opts } = options
    Object.entries(opts).forEach(([key, value]) => {
      db[key] = new Nedb({
        filename: filename(value),
        autoload: true
      })
    })
    this.db = db
  }
}
export default LocalDb
